
#---------------------------
# INCM Output Module

sub INCM_Output {
	my($flag) = @_;

	$point=$flag;
	$all_read = 0;
	unless($point =~/^\d\d\d\d\/\d\d\/\d\d,\d\d:\d\d$/){
		$all_read = 1;
	}

	&ReadConfig_INCM($file_config);

	$title = "$config{'bbstitle'}";

	print	"Content-type: text/html\n\n",
		"#T:$title\n","#RP:DATE\n",
		'#F:POST,$C,mode=msg&resno=$Sr&name=$N&email=$E&sub=$T&comment=$M&url=$H&pwd=$K&color=800000',"\n";

	%amp=  (">","&gt;", "<","&lt;", "\"","&quot;", "&","&amp;");
	%unamp=("gt",">",   "lt","<",   "quot","\"",   "amp","&");

	&ReadData_INCM;

	require './getconfig.pl';
	&ReadSysop;
	&LanguageLoad;

	for($i=0; $i<=$max_number; $i++ ){
		&GetData($i);
		if ($number!=0){
			$test = &FormatDateTime_INCM($time);
			if($test =~ s/^(..)(..\/..\/..)\D+(..:..):..$/$2,$3/ ){
				if("$1$test" ge $point || $all_read == 1 ){
					if ( $admin_name eq $name ) {
						$name = $name." [admin]";
					}
					$dummy = &SysopCheck($name);
					if ( $dummy ne '' ) {
						$name = $name." [sysop]";
					}
					if ( $reply ne '' ) {
						my($anumber,$areply,$areply_count,$areply_time,$atime,$asubject,$aname,$aemail,$ahp,$aicq,$aip,$apassword,$acomment,$amenu,$aremote_host,$aflag_fin,$auid) = split(/<>/,$datalist{$reply});;
						$subject = "T:Re $asubject\n"."N:$name\n";
					} else {
						if ( $config{'menu_use'} != 0 ) {
							if ( 0 != $flag_fin ) {
								$subject="T:<$label{'HEADDER_KIND1_END'}> [ $menu ] $subject\n"."N:$name\n";
							} else {
								$subject="T:[ $menu ] $subject\n"."N:$name\n";
							}
						} else {
							$subject="T:$subject\n"."N:$name\n";
						}

					}
					$subject=~s/&(gt|lt|amp|quot);/$unamp{$1}/eg;

					$mail= "E:$mail\n"  if $mail;
					$hp=   "H:$hp\n"    if $hp;

					if ($icq ne '') { $comment = "ICQ : $icq\n".$comment; }

					$comment =~ s/<BR>/\n/g;
					$comment =~ s/&(gt|lt|amp|quot);/$unamp{$1}/eg;
					$comment =~ s/\n\n\n\n+/\n\n\n/g;
					$comment =~ s/^\n+//;
					$comment =~ s/\n+$//;
					$comment =~ s/\n\.\n/\n \.\n/;
					$comment =~ s/^\.\n/ \.\n/;

					print "S:$number,$reply,$test,\n",$subject,$hp,$mail,"M:\n$comment\n.\n";
				}
			}
		}
	}
	exit;
}


#---------------------------
# READ CONFIG INCM

sub ReadConfig_INCM {
	my($filename) = @_;
	my($name,$value);
	open(FILE,"$filename") || exit;
	while(<FILE>){
		chop;
		($name,$value) = split(/<>/);
		$config{ $name } = $value;
	}
	close(FILE);
}

#---------------------------
# READ DATA INCM

sub ReadData_INCM {
	my($number,$reply);
	my($lockhandle);

	$max_number = 0;
	$uid_number = 0;
	@topiclist = ();
	@replylist = ();

	unless (-e "$file_data") {
		open(FILE,">$file_data") || exit;
		close(FILE);
		chmod( 0666, $file_data );
	} else {
		$lockhandle = &my_flock(basename => "$board") or exit;
		open(FILE,"$file_data") || &Error ("can't open $file_data");
		while(<FILE>){
			chop;
			($number,$reply) = split(/<>/);
			$datalist{$number} = $_;
			if ( $max_number < $number ) { $max_number = $number; }
		}
		close(FILE);
		&my_funlock($lockhandle);
	}
}

#---------------------------
# FormatDateTime INCM

sub FormatDateTime_INCM {
	my($atime) = @_;
	my($ayear,$date) = "";

	$ENV{'TZ'} = "JST-9";
	my($sec,$min,$hour,$mday,$mon,$year,$dayofweek) = gmtime($atime+$timezone*60*60);

	if ($year < 99) { $year += 100; }
	$year += 1900;
	$mon++;
	if ($mon < 10) { $mon = "0$mon";}
	if ($mday < 10) { $mday = "0$mday";}
	if ($hour < 10) { $hour = "0$hour";}
	if ($min < 10) { $min = "0$min";}
	if ($sec < 10) { $sec = "0$sec";}

	$date = "$year/$mon/$mday,$hour:$min:$sec";

	$date;
}

1;
