
#---------------------------
# USER AGENT

sub User_Agent {
	my($user_agent, $remote_host) = @_;

	if($user_agent =~ /^Mozilla\/.+\(compatible\; MSIE .+\;.+\)/) {
		if($user_agent =~ /NetCaptor ([0-9\.]+)/) {
			$browser = 'NetCaptor';
			$browser_v = $1;
		} elsif($user_agent =~ /Opera ([0-9\.]+)/) {
			$browser = 'Opera';
			$browser_v = $1;
		} else {
			$browser = 'InternetExplorer';
			$user_agent2 = $user_agent;
			$user_agent2 =~ s/ //g;
			@buff = split(/\;/, $user_agent2);
			@version_buff = grep(/MSIE/i, @buff);
			$browser_v = $version_buff[0];
			$browser_v =~ s/MSIE//g;
			if($browser_v =~ /^([0-9]+)\.([0-9]+)/) {
        			$browser_v = "$1\.$2";
			}
		}

		if($user_agent =~ /Windows 3\.1/i) {
			$platform = 'Windows';
			$platform_v = '3.1';
		} elsif($user_agent =~ /Win32/i) {
			$platform = 'Windows';
			$platform_v = '32';
		} elsif($user_agent =~ /Windows 95/i) {
			$platform = 'Windows';
			$platform_v = '95';
		} elsif($user_agent =~ /Windows 98/i) {
			$platform = 'Windows';
			if($user_agent =~ /Win 9x 4\.90/) {
				$platform_v = 'Me';
			} else {
				$platform_v = '98';
			}
		} elsif($user_agent =~ /Windows NT 5\.0/i) {
			$platform = 'Windows';
			$platform_v = '2000';
		} elsif($user_agent =~ /Windows NT/i 
				&& $user_agent !~ /Windows NT 5\.0/i) {
			$platform = 'Windows';
			$platform_v = 'NT';
		} elsif($user_agent =~ /Windows CE/i) {
			$platform = 'Windows';
			$platform_v = 'CE';
		} elsif($user_agent =~ /Mac/i) {
			$platform = 'MacOS';
			if($user_agent =~ /Mac_68000/i) {
				$platform_v = '68K';
			} elsif($user_agent =~ /Mac_PowerPC/i) {
				$platform_v = 'PowerPC';
			}
		} elsif($user_agent =~ /WebTV/i) {
			$platform = 'WebTV';
			@buff2 = split(/ /, $user_agent);
			@buff3 = split(/\//, $buff2[1]);
			$platform_v = $buff3[1];
		} else {
			$platform = '';
			$platform_v = '';
		}
	} elsif($user_agent =~ /^Mozilla\/([0-9\.]+).*\(.+\; [NIU]/) {
		$browser = 'NetscapeNavigator';
		$browser_v = $1;

		if($user_agent =~ /Win95/) {
			$platform = 'Windows';
			$platform_v = '95';
		} elsif($user_agent =~ /Win 9x 4\.90/i) {
			$platform = 'Windows';
			$platform_v = 'Me';
		} elsif($user_agent =~ /Win98/i) {
			$platform = 'Windows';
			$platform_v = '98';
		} elsif($user_agent =~ /WinNT/i) {
			$platform = 'Windows';
			$platform_v = 'NT';
		} elsif($user_agent =~ /Windows NT 5\.0/i) {
			$platform = 'Windows';
			$platform_v = '2000';
		} elsif($user_agent =~ /Macintosh/i) {
			$platform = 'MacOS';
			if($user_agent =~ /68K/i) {
				$platform_v = '68K';
			} elsif($user_agent =~ /PPC/i) {
				$platform_v = 'PowerPC';
			}
		} elsif($user_agent =~ /SunOS/i) {
			$platform = 'SunOS';
			@buff2 = split(/\;/, $user_agent);
			@buff3 = split(/ /, $buff2[2]);
			$platform_v = $buff3[2];
		} elsif($user_agent =~ /Linux/i) {
			$platform = 'Linux';
			@buff2 = split(/ /, $user_agent);
			$flag = 0;
			for $key (@buff2) {
				if($flag) {
					$platform_v = $key;
					last;
				}
				$flag = 1 if($key =~ /^Linux$/i);
			}
		} elsif($user_agent =~ /FreeBSD/i) {
			$platform = 'FreeBSD';
			@buff2 = split(/ /, $user_agent);
			$flag = 0;
			for $key (@buff2) {
				if($flag) {
					$platform_v = $key;
					last;
				}
				$flag = 1 if($key =~ /^FreeBSD$/i);
			}
		} elsif($user_agent =~ /NetBSD/i) {
			$platform = 'NetBSD';
			$platform_v = '';
		} elsif($user_agent =~ /AIX/i) {
			$platform = 'AIX';
			$platform_v = '';
		} elsif($user_agent =~ /IRIX/i) {
			$platform = 'IRIX';
			@buff2 = split(/ /, $user_agent);
			$flag = 0;
			for $key (@buff2) {
				if($flag) {
					$platform_v = $key;
					last;
				}
				$flag = 1 if($key =~ /^IRIX$/i);
			}
		} elsif($user_agent =~ /HP-UX/i) {
			$platform = 'HP-UX';
			$platform_v = '';
		} elsif($user_agent =~ /OSF1/i) {
			$platform = 'OSF1';
			@buff2 = split(/ /, $user_agent);
			$flag = 0;
			for $key (@buff2) {
				if($flag) {
					$platform_v = $key;
					last;
				}
				$flag = 1 if($key =~ /^OSF1$/i);
			}
		} else {
			$platform = '';
			$platform_v = '';
		}
	} else {
		$platform = '';
		$platform_v = '';
		$browser = '';
		$browser_v = '';
	}

	return ($platform, $platform_v, $browser, $browser_v);

}

1;
